
module.exports = function (RED) {
    "use strict";
    var q = require('q');
    var fs = require("fs-extra");
    var easyimg = require("easyimage");
    var verror = require('verror');
    var webdriver = require("selenium-webdriver"),
        By = webdriver.By,
        until = webdriver.until;

    console.log('Registering Plugin Service')
    const FinderPluginSvc = require('@torpadev/orpa-page-object-finder').FinderPluginSvc;
    const Dispatcher = require('@torpadev/orpa-page-object-finder').Dispatcher;
    console.log('Registered Plugin Service: Page Object Finder');
    // const finderSvc = new FinderPluginSvc();
    const dispatcher = new Dispatcher();
    dispatcher.registerObject("FinderPluginSvc", FinderPluginSvc);
    // console.log(finderSvc);
    console.log(dispatcher);
    try{
        dispatcher.start(9010);
    }catch(ex){
        console.error(ex);
    }
    


    function ConfigureWebPages(n) {
        RED.nodes.createNode(this, n);

        this.usecount = 0;

        this.url = n.url;
        this.name = n.name;
        this.framePath = n.framePath;
        this.elements = n.elements;
        this.markers = n.markers;

        var node = this;
        // node.log(n);
        this.register = function () {
            node.usecount += 1;
        };

        this.deregister = function () {
            node.usecount -= 1;
            if (node.usecount == 0) {
            }
        };
    }

    RED.nodes.registerType("web-page", ConfigureWebPages);

    RED.httpAdmin.get("/plugins/*",function(req,res) {
        var options = {
            root: __dirname + '/plugins/',
            dotfiles: 'deny'
        };
        res.sendFile(req.params[0], options);
    });
}